/*----------------------------------------------------------------------------------------------------------------*/
// Saguenay Rivers:
// CREATED BY DANY:
// OCTOBRE 2006:
// FROM RMS MAPS BY ENSEMBLE:
/*----------------------------------------------------------------------------------------------------------------*/
include "mercenaries.xs";
// Main entry point for random map script
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/   
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
	    int subCiv3=-1;
/*----------------------------------------------------------------------------------------------------------------*/
	    // ALL IROQUOIS ALL THE TIME:
        if (rmAllocateSubCivs(4) == true)
/*----------------------------------------------------------------------------------------------------------------*/		
   {
/*----------------------------------------------------------------------------------------------------------------*/   
		subCiv0=rmGetCivID("Iroquois");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Iroquois");

		subCiv1=rmGetCivID("Iroquois");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Iroquois");

		subCiv2=rmGetCivID("Iroquois");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Iroquois");

		subCiv3=rmGetCivID("Iroquois");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Iroquois");
/*----------------------------------------------------------------------------------------------------------------*/		
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/   
// ****************************************** PICKS THE MAP SIZE: *********************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
    int playerTiles=25000;
	
	// if (cNumberNonGaiaPlayers >4)
	//	playerTiles = 19500;

	int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	rmEchoInfo("Map size="+size+"m x "+size+"m");
	rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/   
// ************************************* DEFINE THE MAP PARAMETERS: ********************************************* //
/*----------------------------------------------------------------------------------------------------------------*/
	  // PICKS A DEFAULT WATER HEIGHT:
	  //rmSetSeaLevel(3.0);	// this is height of river surface compared to surrounding land. River depth is in the river XML.
	    rmSetSeaLevel(1.0); // FROM SAGUENAY:
	  
	  // SET THE WIND MAGNITUDE:
	  rmSetWindMagnitude(2);

	  // ADD MAP TERRAIN BY HEIGHT INFO:
	  //rmAddMapTerrainByHeightInfo("yukon\ground2_yuk", 6.0, 9.0, 1.0);
	  //rmAddMapTerrainByHeightInfo("yukon\ground3_yuk", 9.0, 16.0);
	  
	  // PICKS THE DEFAULT TERRAIN:
	  //rmSetBaseTerrainMix("andes_grass_a");
	    rmSetBaseTerrainMix("saguenay tundra"); // FROM SAGUENAY:
      
	  // PICKS THE TERRAIN INITIALIZATION:
	  //rmTerrainInitialize("andes\ground10_and", 4);
	    //rmTerrainInitialize("saguenay\ground1_sag",10); // FROM SAGUENAY:
		  rmTerrainInitialize("saguenay\ground1_sag", 4); // FROM SAGUENAY:
	  
	  // SET THE MAP TYPE:
	  //rmSetMapType("andes");
	    rmSetMapType("saguenay"); // FROM SAGUENAY:
	  //rmSetMapType("grass");
	    rmSetMapType("grass"); // FROM SAGUENAY:
	  //rmSetMapType("land");
	    rmSetMapType("water"); // FROM SAGUENAY:
	    
      
	  // SET THE LIGHTING:
	  //rmSetLightingSet("sonora");
	    rmSetLightingSet("saguenay"); // FROM SAGUENAY:

	  // MAKE THE CORNERS:
	  rmSetWorldCircleConstraint(true);

	  // CHOOSE THE MERCS:
	  chooseMercs();

	  // MAKE IT SNOW:
      //rmSetGlobalSnow( 0.7 );
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES. THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*----------------------------------------------------------------------------------------------------------------*/
      int classPlayer=rmDefineClass("player");
      rmDefineClass("startingUnit");
	  rmDefineClass("importantItem");
      rmDefineClass("natives");
	  rmDefineClass("nuggets");
	  rmDefineClass("socketClass");
	  rmDefineClass("classForest");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/   
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************** //
/*----------------------------------------------------------------------------------------------------------------*/
//  NONE FOR NOW: 
/*----------------------------------------------------------------------------------------------------------------*/
      // MAP EDGE CONSTRAINTS:
	  int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(25), rmZTilesToFraction(25), 1.0-rmXTilesToFraction(25), 1.0-rmZTilesToFraction(25), 0.01);
	  //int coinEdgeConstraint=rmCreateBoxConstraint("coin edge of map", rmXTilesToFraction(7), rmZTilesToFraction(7), 1.0-rmXTilesToFraction(7), 1.0-rmZTilesToFraction(7), 0.01);
	    int coinEdgeConstraint=rmCreateBoxConstraint("coin edge of map", rmXTilesToFraction(25), rmZTilesToFraction(25), 1.0-rmXTilesToFraction(25), 1.0-rmZTilesToFraction(25), 0.01);
	    int nuggetEdgeConstraint=rmCreateBoxConstraint("nugget edge of map", rmXTilesToFraction(25), rmZTilesToFraction(25), 1.0-rmXTilesToFraction(25), 1.0-rmZTilesToFraction(25), 0.01);
	    int sheepEdgeConstraint=rmCreateBoxConstraint("sheep edge of map", rmXTilesToFraction(30), rmZTilesToFraction(30), 1.0-rmXTilesToFraction(30), 1.0-rmZTilesToFraction(30), 0.01);
	    int elkEdgeConstraint=rmCreateBoxConstraint("elk edge of map", rmXTilesToFraction(30), rmZTilesToFraction(30), 1.0-rmXTilesToFraction(30), 1.0-rmZTilesToFraction(30), 0.01);
	    int forestEdgeConstraint=rmCreateBoxConstraint("forest edge of map", rmXTilesToFraction(30), rmZTilesToFraction(30), 1.0-rmXTilesToFraction(30), 1.0-rmZTilesToFraction(30), 0.01);
	    
   
	  
	  // CARDINAL DIRECTIONS:
	  int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
	  int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	  int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.75, 0.75, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	  int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

	  // CREATE BOX CONSTRAINT:
	  int NWconstraint = rmCreateBoxConstraint("stay in NW portion", 0, 0.5, 1, 1);
	  int SEconstraint = rmCreateBoxConstraint("stay in SE portion", 0, 0, 1, 0.5);
	  int NEconstraint = rmCreateBoxConstraint("stay in NE portion", 0.65, 0.0, 1, 1);
	  int SWconstraint = rmCreateBoxConstraint("stay in SW portion", 0, 0.0, 0.5, 1);
	  int extremeNEconstraint = rmCreateBoxConstraint("stay deep into NE portion", 0.6, 0.0, 1.0, 1.0);
      int Westconstraint = rmCreateBoxConstraint("stay in East Box", 0, 1.0, 0.4, 0.6); 
	  int Eastconstraint = rmCreateBoxConstraint("stay in West Box", 1.0, 0.0, 0.6, 0.4); 
	  
	  // PLAYER CONSTRAINTS:
	  int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 20.0);
	 
	  // NATURE AVOIDANCE:
	  int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 20.0);
	  //int forestAvoidForest=rmCreateTypeDistanceConstraint("forest vs. forest", rmClassID("classForest"), 35.0);
  	  int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 35.0);
	  int avoidCoinFar=rmCreateTypeDistanceConstraint("avoid coin far", "gold", 20.0);
	  int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 10.0);
	  
	  // AVOID IMPASSABLE LAND:
	  int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
      int avoidRiver = rmCreateTerrainDistanceConstraint("avoid river", "Land", false, 5.0);	  
	  
	  // UNIT AVOIDANCE:
	  int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
      int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);
   	  int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 10.0);
	  int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 10.0);
      int avoidNugget=rmCreateClassDistanceConstraint("stuff avoids nuggets", rmClassID("nuggets"), 35.0);
	  int avoidNuggetFar=rmCreateTypeDistanceConstraint("nugget avoid nugget far", "AbstractNugget", 45.0);
	  int avoidNuggetsSmall=rmCreateClassDistanceConstraint("objects avoid starting nuggets small", rmClassID("nuggets"), 10.0);
   	  int avoidTC=rmCreateTypeDistanceConstraint("avoid Town Center", "TownCenter", 20.0);
	  int avoidElk=rmCreateTypeDistanceConstraint("stuff avoid elk", "elk", 20.0);
	  int elkAvoidElk=rmCreateTypeDistanceConstraint("elk avoids elk", "elk", 60.0);
	  
	  // DECORATION AVOIDANCE:
      int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 8.0);
	  
	  // TRADE ROUTE AVOIDANCE:
	  int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 8.0);
	  int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("socketClass"), 8.0);
	  
	  // Constraint to avoid water.
      int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 8.0);
      int avoidWater16 = rmCreateTerrainDistanceConstraint("avoid water 16", "Land", false, 16.0);
  
/*================================================================================================================*/
// ********************************************** DEFINE OBJECTS: *********************************************** //
// ************************* THESE OBJECTS ARE ALL DEFINED SO THEY CAN BE PLACED LATER: ************************* //
// NONE FOR NOW:
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// *** Set up player starting locations. Circular around the outside of the map.
// rmPlacePlayersCircular(0.1, 0.9, rmDegreesToRadians(5.0));
/*----------------------------------------------------------------------------------------------------------------*/
// ******************************* DEFINE THE STARTING POSITION OF THE PLAYERS: ********************************* //
/*----------------------------------------------------------------------------------------------------------------*/
	if ( cNumberTeams == 2 )
/*----------------------------------------------------------------------------------------------------------------*/	
	{
/*----------------------------------------------------------------------------------------------------------------*/	
		rmSetPlacementTeam(0);
/*----------------------------------------------------------------------------------------------------------------*/		
		rmSetPlacementSection(0.15, 0.35);
		if (cNumberNonGaiaPlayers >6)
		{
			rmSetPlacementSection(0.13, 0.37);
		}
		rmPlacePlayersCircular(0.35, 0.40, 0.0);
/*----------------------------------------------------------------------------------------------------------------*/
		rmSetPlacementTeam(1);
/*----------------------------------------------------------------------------------------------------------------*/		
		rmSetPlacementSection(0.65, 0.85);
		if (cNumberNonGaiaPlayers >6)
		{
			rmSetPlacementSection(0.63, 0.87);
		}
		rmPlacePlayersCircular(0.35, 0.40, 0.0);
/*----------------------------------------------------------------------------------------------------------------*/		
	}
/*----------------------------------------------------------------------------------------------------------------*/	
	else
/*----------------------------------------------------------------------------------------------------------------*/	
	{
  		rmSetPlacementSection(0.0, 0.95);
		rmPlacePlayersCircular(0.40, 0.42, 0.0);
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ************************************* DEFINE AND BUILD A NORTH AREA: ***************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
/*	  int northIslandID = rmCreateArea("north island");
	  //rmSetAreaLocation(northIslandID, 0.75, 0.50); 
	    rmSetAreaLocation(northIslandID, 0.0, 1.0); 
	  rmSetAreaWarnFailure(northIslandID, false);
	  //rmSetAreaSize(northIslandID, 0.5, 0.5);
	    rmSetAreaSize(northIslandID, 0.35, 0.35);
	  rmSetAreaCoherence(northIslandID, 0.5);
	  rmSetAreaElevationType(northIslandID, cElevTurbulence);
	  rmSetAreaElevationVariation(northIslandID, 3.0);
	  rmSetAreaBaseHeight(northIslandID, 4.0);
	  rmSetAreaElevationMinFrequency(northIslandID, 0.07);
	  rmSetAreaElevationOctaves(northIslandID, 4);
	  rmSetAreaElevationPersistence(northIslandID, 0.5);
	  rmSetAreaElevationNoiseBias(northIslandID, 1);
	  rmSetAreaObeyWorldCircleConstraint(northIslandID, false);
	  //rmSetAreaMix(northIslandID, "andes_grass_b");
	    rmSetAreaMix(northIslandID, "saguenay grass");
	  //rmSetAreaMix(northIslandID, "amazon grass");*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/   
// ************************************* DEFINE AND BUILD A SOUTH AREA: ***************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
 /*     int southIslandID = rmCreateArea("south island");
      //rmSetAreaLocation(southIslandID, 0, 0.5); 
	    rmSetAreaLocation(southIslandID, 1.0, 0.0); 
      rmSetAreaWarnFailure(southIslandID, false);
      //rmSetAreaSize(southIslandID, 0.5, 0.5);
	    rmSetAreaSize(southIslandID, 0.35, 0.35);
      rmSetAreaCoherence(southIslandID, 0.5);
	  rmSetAreaElevationType(southIslandID, cElevTurbulence);
      rmSetAreaElevationVariation(southIslandID, 5.0);
      rmSetAreaBaseHeight(southIslandID, 3.0);
      rmSetAreaElevationMinFrequency(southIslandID, 0.07);
      rmSetAreaElevationOctaves(southIslandID, 4);
      rmSetAreaElevationPersistence(southIslandID, 0.5);
	  rmSetAreaElevationNoiseBias(southIslandID, 1); 
      //rmAddAreaTerrainLayer(southIslandID, "andes\ground10_and", 0, 5);
	    rmAddAreaTerrainLayer(southIslandID, "saguenay\ground5_sag", 0, 4);
      //rmAddAreaTerrainLayer(southIslandID, "andes\ground07_and", 3, 8);
      //rmAddAreaTerrainLayer(southIslandID, "andes\ground4_and", 6, 8);
	  rmSetAreaObeyWorldCircleConstraint(southIslandID, false);
	  //rmSetAreaMix(southIslandID, "andes_grass_a");
	    rmSetAreaMix(southIslandID, "saguenay grass");*/
/*----------------------------------------------------------------------------------------------------------------*/
      rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/   
// ************************************* DEFINE THE SET UP PLAYER AREAS: **************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
      float playerFraction=rmAreaTilesToFraction(100);
/*----------------------------------------------------------------------------------------------------------------*/   
      for(i=1; <cNumberPlayers)
/*----------------------------------------------------------------------------------------------------------------*/   
   {
/*----------------------------------------------------------------------------------------------------------------*/   
      // CREATE THE AREA:
      int id=rmCreateArea("Player"+i);
      
	  // ASSIGN TO THE PLAYER:
      rmSetPlayerArea(i, id);
     
	  // SET THE SIZE:
      rmSetAreaSize(id, playerFraction, playerFraction);
      
	  // ADD AREA TO CLASS:
	  rmAddAreaToClass(id, classPlayer);
      
	  // SET AREA MIN AND MAX BLOBS:
	  rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
	  
	  // ADD AREA CONSTRAINTS:
      rmAddAreaConstraint(id, playerConstraint); 
      rmAddAreaConstraint(id, playerEdgeConstraint);
      
	  // SET AREA LOC PLAYER:
	  rmSetAreaLocPlayer(id, i);
	  
	  // SET AREA TERRAIN TYPE:
	  rmSetAreaTerrainType(id, "carolina\marshflats");
	  
	  // SET AREA BASE HEIGHT:
	  //rmSetAreaBaseHeight(id, 18.0);
     
      // SET AREA WARN FAILURE:
	  rmSetAreaWarnFailure(id, false);
/*----------------------------------------------------------------------------------------------------------------*/	 
   }
/*----------------------------------------------------------------------------------------------------------------*/
      // BUILD THE AREAS:
      rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE TRADE ROUTES: *************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
	    rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
		//rmAddObjectDefConstraint(socketID, avoidElk);
		//rmAddObjectDefConstraint(socketID, avoidCoin);
		//rmAddObjectDefConstraint(socketID, avoidNugget);
	    rmSetObjectDefAllowOverlap(socketID, true);
	    rmSetObjectDefMinDistance(socketID, 0.0);
	    rmSetObjectDefMaxDistance(socketID, 10.0);
/*----------------------------------------------------------------------------------------------------------------*/	
	    int tradeRouteID = rmCreateTradeRoute();
/*----------------------------------------------------------------------------------------------------------------*/
        rmAddTradeRouteWaypoint(tradeRouteID, 0.0, 1.0);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.35, 0.6);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.50, 0.50);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.6, 0.35);
        rmAddTradeRouteWaypoint(tradeRouteID, 1.0, 0.0);
/*----------------------------------------------------------------------------------------------------------------*/		
		bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
	    if(placedTradeRoute == false)
	    rmEchoError("Failed to place trade route one");
/*----------------------------------------------------------------------------------------------------------------*/
// ***************************** ADD THE MEETING SOCKETS ALONG THE TRADE ROUTE: ********************************* //
/*----------------------------------------------------------------------------------------------------------------*/
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
	    vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.17);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

	    socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.33);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	
	    socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.50);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	
	    socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.66);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

	    socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.83);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
/*----------------------------------------------------------------------------------------------------------------*/
// **************************************** DEFINE AND PLACE THE RIVER: ***************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
           	// RIVER 1:		
			//int riverID = rmRiverCreate(-1, "Andes River", 12, 8, 3, 3);
			//int riverID = rmRiverCreate(-1, "Andes River", 10, 10, 6, 5);
			  int riverID = rmRiverCreate(-1, "Pampas River", 10, 10, 6, 5);
			//rmRiverAddWaypoint(riverID, 0.9, 1.0);
			  rmRiverAddWaypoint(riverID, 0.5, 1.0);
			rmRiverAddWaypoint(riverID, 0.5, 0.65);
			//rmRiverAddWaypoint(riverID, 0.0, 0.75);
			  rmRiverAddWaypoint(riverID, 1.0, 0.5);
			rmRiverSetShallowRadius(riverID, 10);
			rmRiverAddShallow(riverID, rmRandFloat(0.45, 0.65));
			rmRiverSetBankNoiseParams(riverID, 0.07, 2, 1.5, 10.0, 0.667, 3.0);
			rmRiverBuild(riverID);
/*----------------------------------------------------------------------------------------------------------------*/
			// RIVER 2:
			//int river2ID = rmRiverCreate(-1, "Andes River", 10, 10, 6, 5);
			  int river2ID = rmRiverCreate(-1, "Pampas River", 10, 10, 6, 5);
			//rmRiverAddWaypoint(river2ID, 0.9, 0.0);
			  rmRiverAddWaypoint(river2ID, 0.5, 0.0);
			rmRiverAddWaypoint(river2ID, 0.5, 0.35);
			//rmRiverAddWaypoint(river2ID, 0.0, 0.16);
			  rmRiverAddWaypoint(river2ID, 0.0, 0.5);
			rmRiverSetShallowRadius(river2ID, 10);
			rmRiverAddShallow(river2ID, rmRandFloat(0.45, 0.65));
			rmRiverSetBankNoiseParams(river2ID, 0.07, 2, 1.5, 10.0, 0.667, 3.0);
			rmRiverBuild(river2ID);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/   
// ********************************** DEFINE AND PLACE THE NATIVES TRIBES: ************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    	if (subCiv0 == rmGetCivID("iroquois"))
	{  
		int iroquoisVillage1ID = -1;
		iroquoisVillage1ID = rmCreateGrouping("iroquois village 1", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquoisVillage1ID, 0.0);
		//rmSetGroupingMaxDistance(iroquoisVillage1ID, rmXFractionToMeters(0.5));
		  rmSetGroupingMaxDistance(iroquoisVillage1ID, 0.0);
		rmAddGroupingConstraint(iroquoisVillage1ID, avoidImpassableLand);
		rmAddGroupingToClass(iroquoisVillage1ID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquoisVillage1ID, avoidNatives);
		//rmAddGroupingConstraint(iroquoisVillage1ID, insideCircleConstraint);
		//rmPlaceGroupingAtLoc(iroquoisVillage1ID, 0, 0.5, 0.5);
		  rmPlaceGroupingAtLoc(iroquoisVillage1ID, 0, 0.10, 0.60);
	} 
/*----------------------------------------------------------------------------------------------------------------*/
		if (subCiv1 == rmGetCivID("iroquois"))
	{  
		int iroquoisVillage2ID = -1;
		iroquoisVillage2ID = rmCreateGrouping("iroquois village 2", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquoisVillage2ID, 0.0);
		//rmSetGroupingMaxDistance(iroquoisVillage2ID, rmXFractionToMeters(0.5));
		  rmSetGroupingMaxDistance(iroquoisVillage2ID, 0.0);
		rmAddGroupingConstraint(iroquoisVillage2ID, avoidImpassableLand);
		rmAddGroupingToClass(iroquoisVillage2ID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquoisVillage2ID, avoidNatives);
		//rmAddGroupingConstraint(iroquoisVillage2ID, insideCircleConstraint);
		//rmPlaceGroupingAtLoc(iroquoisVillage2ID, 0, 0.5, 0.5);
		  rmPlaceGroupingAtLoc(iroquoisVillage2ID, 0, 0.40, 0.89);
	} 
/*----------------------------------------------------------------------------------------------------------------*/
		if (subCiv2 == rmGetCivID("iroquois"))
	{  
		int iroquoisVillage3ID = -1;
		iroquoisVillage3ID = rmCreateGrouping("iroquois village 3", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquoisVillage3ID, 0.0);
		//rmSetGroupingMaxDistance(iroquoisVillage3ID, rmXFractionToMeters(0.5));
		  rmSetGroupingMaxDistance(iroquoisVillage3ID, 0.0);
		rmAddGroupingConstraint(iroquoisVillage3ID, avoidImpassableLand);
		rmAddGroupingToClass(iroquoisVillage3ID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquoisVillage3ID, avoidNatives);
		//rmAddGroupingConstraint(iroquoisVillage3ID, insideCircleConstraint);
		//rmPlaceGroupingAtLoc(iroquoisVillage3ID, 0, 0.5, 0.5);
		  rmPlaceGroupingAtLoc(iroquoisVillage3ID, 0, 0.60, 0.10);
	} 
/*----------------------------------------------------------------------------------------------------------------*/
		if (subCiv3 == rmGetCivID("iroquois"))
	{  
		int iroquoisVillage4ID = -1;
		iroquoisVillage4ID = rmCreateGrouping("iroquois village 4", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquoisVillage4ID, 0.0);
		//rmSetGroupingMaxDistance(iroquoisVillage4ID, rmXFractionToMeters(0.5));
		  rmSetGroupingMaxDistance(iroquoisVillage4ID, 0.0);
		rmAddGroupingConstraint(iroquoisVillage4ID, avoidImpassableLand);
		rmAddGroupingToClass(iroquoisVillage4ID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquoisVillage4ID, avoidNatives);
		//rmAddGroupingConstraint(iroquoisVillage4ID, insideCircleConstraint);
		//rmPlaceGroupingAtLoc(iroquoisVillage4ID, 0, 0.5, 0.5);
		  rmPlaceGroupingAtLoc(iroquoisVillage4ID, 0, 0.89, 0.43);
	} 
/*----------------------------------------------------------------------------------------------------------------*/
// **************************** DEFINE THE STARTING TCID AND THE STARTING UNITS: ******************************** //	
/*----------------------------------------------------------------------------------------------------------------*/
	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
    rmSetObjectDefMinDistance(startingUnits, 5.0);
    rmSetObjectDefMaxDistance(startingUnits, 10.0);
	rmAddObjectDefConstraint(startingUnits, avoidAll);

	int startingTCID= rmCreateObjectDef("TownCenter");
	if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
		rmSetObjectDefMinDistance(startingTCID, 5.0);
        rmSetObjectDefMaxDistance(startingTCID, 20.0);
		rmAddObjectDefConstraint(startingTCID, playerEdgeConstraint);
		rmAddObjectDefConstraint(startingTCID, avoidTC);
		// Give it a little wiggle room for maps with greater than four players
		if ( cNumberNonGaiaPlayers > 4 )
		{
			rmSetObjectDefMinDistance(startingTCID, 0.0);
			rmSetObjectDefMaxDistance(startingTCID, 6.0);
		}
	}
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************* DEFINE THE STARTING RESOURCES: ***************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
	  int StartBerryBushID=rmCreateObjectDef("starting berry bush");
	  rmAddObjectDefItem(StartBerryBushID, "BerryBush", 2, 4.0);
	  rmSetObjectDefMinDistance(StartBerryBushID, 12.0);
	  rmSetObjectDefMaxDistance(StartBerryBushID, 16.0);
	  rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);
	
      int playersheepID=rmCreateObjectDef("player sheep herd");
      rmAddObjectDefItem(playersheepID, "sheep", rmRandInt(6,8), 6.0);
      rmSetObjectDefMinDistance(playersheepID, 30.0);
      rmSetObjectDefMaxDistance(playersheepID, 35.0);
	  rmAddObjectDefConstraint(playersheepID, sheepEdgeConstraint);
	  rmAddObjectDefConstraint(playersheepID, avoidRiver);
	  rmSetObjectDefCreateHerd(playersheepID, true);
	  
	  int StartPronghornID=rmCreateObjectDef("starting pronghorn");
	  rmAddObjectDefItem(StartPronghornID, "pronghorn", 4, 4.0);
	  rmSetObjectDefMinDistance(StartPronghornID, 5);
	  rmSetObjectDefMaxDistance(StartPronghornID, 12);
	  rmAddObjectDefConstraint(StartPronghornID, avoidStartingUnitsSmall);
	  //rmAddObjectDefConstraint(StartPronghornID, shortAvoidImpassableLand);
	  rmAddObjectDefConstraint(StartPronghornID, avoidTC);
	  rmSetObjectDefCreateHerd(StartPronghornID, true);

	  int playerNuggetID=rmCreateObjectDef("player nugget");
	  rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	  rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
      rmSetObjectDefMinDistance(playerNuggetID, 30.0);
      rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	  rmAddObjectDefConstraint(playerNuggetID, avoidRiver);
	  rmAddObjectDefConstraint(playerNuggetID, avoidCoin);
	  rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	  rmAddObjectDefConstraint(playerNuggetID, nuggetEdgeConstraint);
	  //rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem); // REMOVED BY ENSEMBLE:
	  
	  // starting resources
	  int StartAreaTreeID=rmCreateObjectDef("starting trees");
	  //rmAddObjectDefItem(StartAreaTreeID, "TreeTexasDirt", 1, 0.0);
	    rmAddObjectDefItem(StartAreaTreeID, "TreeSaguenay", 1, 0.0); // FROM SAGUENAY:
	  rmSetObjectDefMinDistance(StartAreaTreeID, 8);
	  rmSetObjectDefMaxDistance(StartAreaTreeID, 14);
	  //rmAddObjectDefConstraint(StartAreaTreeID, avoidStartResource);
	  //rmAddObjectDefConstraint(StartAreaTreeID, shortAvoidImpassableLand);
	  rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);
	  rmAddObjectDefConstraint(StartAreaTreeID, avoidTC);

/*	  int startingOutpostID=rmCreateObjectDef("Starting Outpost");
      rmAddObjectDefItem(startingOutpostID, "Outpost", 1, 0.0);
      rmSetObjectDefMinDistance(startingOutpostID, 20.0);
      rmSetObjectDefMaxDistance(startingOutpostID, 22.0);
      rmAddObjectDefToClass(startingOutpostID, rmClassID("importantItem"));
      rmAddObjectDefConstraint(startingOutpostID, avoidOutpost);
	  rmAddObjectDefConstraint(startingOutpostID, avoidTradeRoute);
	  rmAddObjectDefConstraint(startingOutpostID, avoidImportantItem);
      //rmPlaceObjectDefPerPlayer(startingOutpostID, true, 4); // REMOVED BY ENSEMBLE:

	  int startingBarracksID=rmCreateObjectDef("Starting Barracks");
      rmAddObjectDefItem(startingBarracksID, "barracks", 1, 0.0);
      rmSetObjectDefMinDistance(startingBarracksID, 18.0);
      rmSetObjectDefMaxDistance(startingBarracksID, 24.0);
      rmAddObjectDefToClass(startingBarracksID, rmClassID("importantItem"));
      rmAddObjectDefConstraint(startingBarracksID, avoidOutpostBarracks);
	  rmAddObjectDefConstraint(startingBarracksID, avoidTradeRoute);
	  rmAddObjectDefConstraint(startingBarracksID, avoidImportantItem);
      //rmPlaceObjectDefPerPlayer(startingBarracksID, true, 4); // REMOVED BY ENSEMBLE:

	  int startingBlockhouseID=rmCreateObjectDef("Starting Blockhouse");
      rmAddObjectDefItem(startingBlockhouseID, "Blockhouse", 1, 0.0);
      rmSetObjectDefMinDistance(startingBlockhouseID, 20.0);
      rmSetObjectDefMaxDistance(startingBlockhouseID, 22.0);
      rmAddObjectDefToClass(startingBlockhouseID, rmClassID("importantItem"));
      rmAddObjectDefConstraint(startingBlockhouseID, avoidBlockhouse);
	  rmAddObjectDefConstraint(startingBlockhouseID, avoidTradeRoute);
	  rmAddObjectDefConstraint(startingBlockhouseID, avoidImportantItem);

	  int startingWarHutID=rmCreateObjectDef("Starting War Hut");
      rmAddObjectDefItem(startingWarHutID, "WarHut", 1, 0.0);
      rmSetObjectDefMinDistance(startingWarHutID, 20.0);
      rmSetObjectDefMaxDistance(startingWarHutID, 22.0);
      rmAddObjectDefToClass(startingWarHutID, rmClassID("importantItem"));
      rmAddObjectDefConstraint(startingWarHutID, avoidWarHut);
	  rmAddObjectDefConstraint(startingWarHutID, avoidTradeRoute);
	  rmAddObjectDefConstraint(startingWarHutID, avoidImportantItem);*/

      int playerGoldID=rmCreateObjectDef("player silver ore");
	  int silverType = rmRandInt(1,10);
	  
/*----------------------------------------------------------------------------------------------------------------*/
// ****************************** PLACE THE STARTING TCID AND THE STARTING UNITS: ******************************* //		
/*----------------------------------------------------------------------------------------------------------------*/
	    // Player placement
	    for(i=1; <cNumberPlayers)
	{
		// Place starting units and a TC!
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************** PLACE THE STARTING RESOURCES: ***************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
	/*	// Place extra buildings, unless nomad start.
		if ( rmGetNomadStart() == false )
		{
			// Russians place two blockhouses
			if ( rmGetPlayerCiv(i) == rmGetCivID("Russians"))
			{
				rmPlaceObjectDefAtLoc(startingBlockhouseID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
				rmPlaceObjectDefAtLoc(startingBlockhouseID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
			}
			// Native civs place two war huts.
			else if ( rmGetPlayerCiv(i) ==  rmGetCivID("XPIroquois") ||
						rmGetPlayerCiv(i) ==  rmGetCivID("XPSioux") ||
						rmGetPlayerCiv(i) ==  rmGetCivID("XPAztec"))
			{
				rmPlaceObjectDefAtLoc(startingWarHutID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
				rmPlaceObjectDefAtLoc(startingWarHutID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
			}
			// Everyone else: two outposts and a barracks.
			else
			{
				rmPlaceObjectDefAtLoc(startingOutpostID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
				rmPlaceObjectDefAtLoc(startingOutpostID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
				rmPlaceObjectDefAtLoc(startingBarracksID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
			}
		}
    */
/*----------------------------------------------------------------------------------------------------------------*/	
		rmPlaceObjectDefAtLoc(StartBerryBushID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Place starting resources - DAL
		rmPlaceObjectDefAtLoc(StartPronghornID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Everyone gets two ore groupings, one pretty close, the other a little further away.
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "minegold", 1, 0.0);
		rmAddObjectDefConstraint(playerGoldID, coinEdgeConstraint);
		rmAddObjectDefConstraint(playerGoldID, coinAvoidCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidNuggetsSmall);
		rmAddObjectDefConstraint(playerGoldID, avoidWater8);
		rmAddObjectDefConstraint(playerGoldID, avoidCoin);
		rmSetObjectDefMinDistance(playerGoldID, 25.0);
		rmSetObjectDefMaxDistance(playerGoldID, 30.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver further "+i);
		rmAddObjectDefItem(playerGoldID, "minegold", 1, 0.0);
		rmAddObjectDefConstraint(playerGoldID, coinEdgeConstraint);
		rmAddObjectDefConstraint(playerGoldID, coinAvoidCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidNuggetsSmall);
		rmAddObjectDefConstraint(playerGoldID, avoidWater8);
		rmAddObjectDefConstraint(playerGoldID, avoidCoin);
		rmSetObjectDefMinDistance(playerGoldID, 40.0);
		rmSetObjectDefMaxDistance(playerGoldID, 50.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Everyone gets two bison herds..
		rmPlaceObjectDefAtLoc(playersheepID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		//rmPlaceObjectDefAtLoc(playerBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Player nuggets.
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

/*----------------------------------------------------------------------------------------------------------------*/
		vector closestPoint=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingUnits, i));
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/   
// NONE FOR NOW:
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE CLIFF AREA: ***************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/   
// ************************************* DEFINE AND PLACE THE NUGGETS: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	// DEFINE AND PLACE THE NUGGET EASY SE:
	int nuggeteasyID= rmCreateObjectDef("nugget easy SE"); 
	rmAddObjectDefItem(nuggeteasyID, "Nugget", 1, 0.0);
	rmSetNuggetDifficulty(1, 1);
	rmSetObjectDefMinDistance(nuggeteasyID, 0.0);
	rmSetObjectDefMaxDistance(nuggeteasyID, rmXFractionToMeters(0.5));
  	rmAddObjectDefConstraint(nuggeteasyID, avoidNuggetFar);
  	//rmAddObjectDefConstraint(nuggeteasyID, avoidTownCenter);
  	rmAddObjectDefConstraint(nuggeteasyID, avoidTradeRoute);
	rmAddObjectDefConstraint(nuggeteasyID, nuggetEdgeConstraint);
  	rmAddObjectDefConstraint(nuggeteasyID, avoidAll);
	rmAddObjectDefConstraint(nuggeteasyID, avoidSocket);
	rmAddObjectDefConstraint(nuggeteasyID, avoidElk);
  	rmAddObjectDefConstraint(nuggeteasyID, avoidImpassableLand);
	rmAddObjectDefConstraint(nuggeteasyID, Westconstraint);
	//rmPlaceObjectDefAtLoc(nuggeteasyID, 0, 0.5, 0.5, cNumberNonGaiaPlayers/2);
	  rmPlaceObjectDefAtLoc(nuggeteasyID, 0, 0.0, 1.0, cNumberNonGaiaPlayers);

	// DEFINE AND PLACE THE NUGGET EASY NW:
	int nuggeteasyNWID= rmCreateObjectDef("nugget easy NW"); 
	rmAddObjectDefItem(nuggeteasyNWID, "Nugget", 1, 0.0);
	rmSetNuggetDifficulty(1, 1);
	rmSetObjectDefMinDistance(nuggeteasyNWID, 0.0);
	rmSetObjectDefMaxDistance(nuggeteasyNWID, rmXFractionToMeters(0.5));
  	rmAddObjectDefConstraint(nuggeteasyNWID, avoidNuggetFar);
  	//rmAddObjectDefConstraint(nuggeteasyNWID, avoidTownCenter);
  	rmAddObjectDefConstraint(nuggeteasyNWID, avoidTradeRoute);
	rmAddObjectDefConstraint(nuggeteasyNWID, nuggetEdgeConstraint);
  	rmAddObjectDefConstraint(nuggeteasyNWID, avoidAll);
	rmAddObjectDefConstraint(nuggeteasyNWID, avoidSocket);
	rmAddObjectDefConstraint(nuggeteasyNWID, avoidElk);
  	rmAddObjectDefConstraint(nuggeteasyNWID, avoidImpassableLand);
	rmAddObjectDefConstraint(nuggeteasyNWID, Eastconstraint);
	//rmPlaceObjectDefAtLoc(nuggeteasyNWID, 0, 0.5, 0.5, cNumberNonGaiaPlayers/2);
	  rmPlaceObjectDefAtLoc(nuggeteasyNWID, 0, 1.0, 0.0, cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// NONE FOR NOW:
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE SILVER MINES: ************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------*/
	  // DEFINE AND PLACE THE SILVER MINES RANDOM:
	  for(i=0; < cNumberNonGaiaPlayers)
/*----------------------------------------------------------------------------------------------------------------*/	  
	{
/*----------------------------------------------------------------------------------------------------------------*/	
	  int silverRandomID = rmCreateObjectDef("silverRandom 1"+i);
	  rmAddObjectDefItem(silverRandomID, "mine", 1, 0.0);
      rmSetObjectDefMinDistance(silverRandomID, 0.0);
      rmSetObjectDefMaxDistance(silverRandomID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(silverRandomID, avoidCoinFar);
      rmAddObjectDefConstraint(silverRandomID, avoidAll);
	  rmAddObjectDefConstraint(silverRandomID, avoidSocket);
	  rmAddObjectDefConstraint(silverRandomID, avoidElk);
      rmAddObjectDefConstraint(silverRandomID, avoidWater8);
	  rmAddObjectDefConstraint(silverRandomID, avoidTradeRoute);
	  rmAddObjectDefConstraint(silverRandomID, avoidNatives);
      rmAddObjectDefConstraint(silverRandomID, avoidNuggetsSmall);
	  rmAddObjectDefConstraint(silverRandomID, Eastconstraint);
	  rmAddObjectDefConstraint(silverRandomID, coinEdgeConstraint);
	 // rmPlaceObjectDefAtLoc(silverRandomID, 0, 0.5, 0.5);
	    rmPlaceObjectDefAtLoc(silverRandomID, 0, 1.0, 0.0);
/*----------------------------------------------------------------------------------------------------------------*/	  
   }
/*----------------------------------------------------------------------------------------------------------------*/
	  // DEFINE AND PLACE THE SILVER MINES RANDOM:
	  for(i=0; < cNumberNonGaiaPlayers)
/*----------------------------------------------------------------------------------------------------------------*/	  
	{
/*----------------------------------------------------------------------------------------------------------------*/	
	  int silverRandom2ID = rmCreateObjectDef("silverRandom 2"+i);
	  rmAddObjectDefItem(silverRandom2ID, "mine", 1, 0.0);
      rmSetObjectDefMinDistance(silverRandom2ID, 0.0);
      rmSetObjectDefMaxDistance(silverRandom2ID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(silverRandom2ID, avoidCoinFar);
      rmAddObjectDefConstraint(silverRandom2ID, avoidAll);
	  rmAddObjectDefConstraint(silverRandom2ID, avoidSocket);
	  rmAddObjectDefConstraint(silverRandom2ID, avoidElk);
      rmAddObjectDefConstraint(silverRandom2ID, avoidWater8);
	  rmAddObjectDefConstraint(silverRandom2ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(silverRandom2ID, avoidNatives);
      rmAddObjectDefConstraint(silverRandom2ID, avoidNuggetsSmall);
	  rmAddObjectDefConstraint(silverRandom2ID, Westconstraint);
	  rmAddObjectDefConstraint(silverRandom2ID, coinEdgeConstraint);
	  //rmPlaceObjectDefAtLoc(silverRandom2ID, 0, 0.5, 0.5);
	    rmPlaceObjectDefAtLoc(silverRandom2ID, 0, 0.0, 1.0);
/*----------------------------------------------------------------------------------------------------------------*/	  
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/   
// *********************************** DEFINE AND PLACE THE FORESTS AREAS: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
   int forestTreeID = 0;
   //int numTries=6*cNumberNonGaiaPlayers;
     int numTries=10*cNumberNonGaiaPlayers;
   int failCount=0;
/*----------------------------------------------------------------------------------------------------------------*/   
   for (i=0; <numTries)
/*----------------------------------------------------------------------------------------------------------------*/   
      { 
/*----------------------------------------------------------------------------------------------------------------*/	  
         int forest=rmCreateArea("forest "+i);
         rmSetAreaWarnFailure(forest, false);
         rmSetAreaSize(forest, rmAreaTilesToFraction(175), rmAreaTilesToFraction(350));
         rmSetAreaForestType(forest, "saguenay forest");
		 // rmSetAreaForestType(forest, "dunes");
         rmSetAreaForestDensity(forest, 0.9);
         rmSetAreaForestClumpiness(forest, 0.8);
         rmSetAreaForestUnderbrush(forest, 0.0);
         rmSetAreaMinBlobs(forest, 1);
         rmSetAreaMaxBlobs(forest, 5);
         rmSetAreaMinBlobDistance(forest, 10.0);
         rmSetAreaMaxBlobDistance(forest, 30.0);
         rmSetAreaCoherence(forest, 0.4);
         rmSetAreaSmoothDistance(forest, 10);
         rmAddAreaToClass(forest, rmClassID("classForest")); 
/*----------------------------------------------------------------------------------------------------------------*/         
		 rmAddAreaConstraint(forest, forestConstraint);
/*----------------------------------------------------------------------------------------------------------------*/		 
         rmAddAreaConstraint(forest, avoidAll);
		 rmAddAreaConstraint(forest, avoidRiver);
		 rmAddAreaConstraint(forest, avoidTC);
		 //rmAddAreaConstraint(forest, forestAvoidForest);
		 rmAddAreaConstraint(forest, avoidNatives);
		 rmAddAreaConstraint(forest, avoidElk);
		 rmAddAreaConstraint(forest, avoidCoin);
		 rmAddAreaConstraint(forest, avoidCoinFar);
		 rmAddAreaConstraint(forest, forestEdgeConstraint);
         // rmAddAreaConstraint(forest, avoidBeach); // REMOVED BY ENSEMBLE:
         rmAddAreaConstraint(forest, avoidImpassableLand); 
         rmAddAreaConstraint(forest, avoidTradeRoute); 
		 rmAddAreaConstraint(forest, avoidSocket); 
		 rmAddAreaConstraint(forest, avoidStartingUnits); 
/*----------------------------------------------------------------------------------------------------------------*/         
		 if(rmBuildArea(forest)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
/*----------------------------------------------------------------------------------------------------------------*/			
      } 
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************* DEFINE AND PLACE RANDOM TREES: ***************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int TreeID= rmCreateObjectDef("tree"); 
		rmAddObjectDefItem(TreeID, "TreeSaguenay", 1, 0.0);
		rmSetObjectDefMinDistance(TreeID, 0.0);
        rmSetObjectDefMaxDistance(TreeID, rmXFractionToMeters(0.5));
		//rmAddObjectDefConstraint(TreeID, shortAvoidImpassableLand);
  		rmAddObjectDefConstraint(TreeID, avoidNugget);
  		rmAddObjectDefConstraint(TreeID, avoidSocket);
		rmAddObjectDefConstraint(TreeID, avoidTC);
		rmAddObjectDefConstraint(TreeID, avoidCoin);
		rmAddObjectDefConstraint(TreeID, avoidNatives);
  		rmAddObjectDefConstraint(TreeID, avoidAll);
		rmAddObjectDefConstraint(TreeID, avoidRiver);
		rmAddObjectDefConstraint(TreeID, playerEdgeConstraint);
		rmPlaceObjectDefAtLoc(TreeID, 0, 0.5, 0.5, 45*cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/   
// ********************************* DEFINE AND PLACE THE HUNTABLE ANIMALS: ************************************* //
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      //int elk1ID = rmCreateObjectDef("elk 1"+i);
	    int elk1ID = rmCreateObjectDef("elk 1");
	  rmAddObjectDefItem(elk1ID, "elk", rmRandInt(8,10), 6.0);
      rmSetObjectDefMinDistance(elk1ID, 0.0);
      rmSetObjectDefMaxDistance(elk1ID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(elk1ID, avoidCoinFar);
      rmAddObjectDefConstraint(elk1ID, avoidAll);
	  rmAddObjectDefConstraint(elk1ID, avoidSocket);
	  rmAddObjectDefConstraint(elk1ID, avoidElk);
	  rmAddObjectDefConstraint(elk1ID, elkAvoidElk);
	  rmAddObjectDefConstraint(elk1ID, avoidWater8);
	  //rmAddObjectDefConstraint(elk1ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(elk1ID, avoidNatives);
      rmAddObjectDefConstraint(elk1ID, avoidNuggetsSmall);
	  rmAddObjectDefConstraint(elk1ID, Eastconstraint);
	  rmAddObjectDefConstraint(elk1ID, elkEdgeConstraint);
	  // rmPlaceObjectDefAtLoc(elk1ID, 0, 0.5, 0.5);
	     rmPlaceObjectDefAtLoc(elk1ID, 0, 1.0, 0.0, cNumberNonGaiaPlayers);
/*----------------------------------------------------------------------------------------------------------------*/
      //int elk2ID = rmCreateObjectDef("elk 2"+i);
	    int elk2ID = rmCreateObjectDef("elk 2");
	  rmAddObjectDefItem(elk2ID, "elk", rmRandInt(8,10), 6.0);
      rmSetObjectDefMinDistance(elk2ID, 0.0);
      rmSetObjectDefMaxDistance(elk2ID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(elk2ID, avoidCoinFar);
      rmAddObjectDefConstraint(elk2ID, avoidAll);
	  rmAddObjectDefConstraint(elk2ID, avoidSocket);
	  rmAddObjectDefConstraint(elk2ID, avoidElk);
	  rmAddObjectDefConstraint(elk2ID, elkAvoidElk);
	  rmAddObjectDefConstraint(elk2ID, avoidWater8);
	  //rmAddObjectDefConstraint(elk2ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(elk2ID, avoidNatives);
      rmAddObjectDefConstraint(elk2ID, avoidNuggetsSmall);
	  rmAddObjectDefConstraint(elk2ID, Westconstraint);
	  rmAddObjectDefConstraint(elk2ID, elkEdgeConstraint);
	  // rmPlaceObjectDefAtLoc(elk2ID, 0, 0.5, 0.5);
	     rmPlaceObjectDefAtLoc(elk2ID, 0, 0.0, 1.0, cNumberNonGaiaPlayers);		 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/   
// ********************************* DEFINE AND PLACE THE DOMESTIC ANIMALS: ************************************* // 
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	  //int cow1ID = rmCreateObjectDef("cow 1"+i);
	    int cow1ID = rmCreateObjectDef("cow 1");
	  rmAddObjectDefItem(cow1ID, "cow", rmRandInt(8,10), 6.0);
      rmSetObjectDefMinDistance(cow1ID, 0.0);
      //rmSetObjectDefMaxDistance(cow1ID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(cow1ID, 0.0);
	  //rmAddObjectDefConstraint(cow1ID, avoidCoinFar);
      //rmAddObjectDefConstraint(cow1ID, avoidAll);
      //rmAddObjectDefConstraint(cow1ID, avoidWater8);
	  //rmAddObjectDefConstraint(cow1ID, avoidTradeRoute);
	  //rmAddObjectDefConstraint(cow1ID, avoidNatives);
      //rmAddObjectDefConstraint(cow1ID, avoidNuggetsSmall);
	  //rmAddObjectDefConstraint(cow1ID, Westconstraint);
	  //rmAddObjectDefConstraint(cow1ID, coinEdgeConstraint);
	  //rmPlaceObjectDefAtLoc(cow1ID, 0, 0.5, 0.5);
	    rmPlaceObjectDefAtLoc(cow1ID, 0, 0.575, 0.925);
/*----------------------------------------------------------------------------------------------------------------*/	
	  //int cow2ID = rmCreateObjectDef("cow 2"+i);
	    int cow2ID = rmCreateObjectDef("cow 2");
	  //rmAddObjectDefItem(cow2ID, "cow", rmRandInt(8,10), 0.0);
	    rmAddObjectDefItem(cow2ID, "cow", rmRandInt(8,10), 6.0);
      rmSetObjectDefMinDistance(cow2ID, 0.0);
      //rmSetObjectDefMaxDistance(cow2ID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(cow2ID, 0.0);
	  //rmAddObjectDefConstraint(cow2ID, avoidCoinFar);
      //rmAddObjectDefConstraint(cow2ID, avoidAll);
      //rmAddObjectDefConstraint(cow2ID, avoidWater8);
	  //rmAddObjectDefConstraint(cow2ID, avoidTradeRoute);
	  //rmAddObjectDefConstraint(cow2ID, avoidNatives);
      //rmAddObjectDefConstraint(cow2ID, avoidNuggetsSmall);
	  //rmAddObjectDefConstraint(cow2ID, Westconstraint);
	  //rmAddObjectDefConstraint(cow2ID, coinEdgeConstraint);
	  //rmPlaceObjectDefAtLoc(cow2ID, 0, 0.5, 0.5);
	    rmPlaceObjectDefAtLoc(cow2ID, 0, 0.40, 0.10);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/   
	}  
}  
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************ THIS IS THE END OF THE MAP: ********************************************* //
/*----------------------------------------------------------------------------------------------------------------*/		